function val = ud(problem,x1,x2)
% This file is part of the OPTPDE problem collection
%                 http://www.optpde.net
% It is provided as is, without any warranty, under the 
%
% Creative Commons Attribution-NonCommercial ShareAlike 4.0 International
%
%         http://creativecommons.org/licenses/by-nc-sa/4.0/
%
% Please give proper credits when using this file by referencing the 
% collection. For this purpose detailed bibliography data is 
% available at the collections website 
%                  
%                 http://www.optpde.net
%
% This file contains data for the benchmark problem 
%                      scdist2
% from  2022-04-01 



% remember the size of the input and resize it
[m,n] = size(x1);
x1 = x1(:)';
x2 = x2(:)';

% evaluate the function
val = zeros(size(x1));
ix1 = find(x1 < problem.s);
ix2 = find(x1 >= problem.s);
val(ix1) = x1(ix1).^3 * problem.s^(-3) - 3 * x1(ix1).^2 * problem.s^(-2) + 3 * x1(ix1) * problem.s^(-1) + 2;
val(ix2) = - (3 * problem.m) / (4 * (1 - problem.s)) * (x1(ix2) - problem.s).^4 + problem.m * (x1(ix2) - problem.s).^3 + 3;

% reshape the output
val = reshape(val,m,n);

